Page MenuHomePhabricator

Create a subpage for statistics and charts related to a hashtag search
Closed, ResolvedPublic

Description

The Hashtags tool (https://hashtags.wmflabs.org/) allows users to search for uses of hashtags (e.g. #1Lib1Ref) in Wikimedia edit summaries. Its current functionality is quite basic - a few simple search options and listed results, with the option to download the results as a CSV or read them as JSON.

A number of Wikimedia campaigns use this tool to track edits and would like to be able to delve into the data a little more. We would therefore like to add a page users can click through to for a given search showing more detailed statistics, graphs, and charts.

Possible data that could be shown on this page includes:

  • Number of contributions per Wikimedia project [Graph/Table]
  • Number of edits by user (perhaps just the top 10) [Table]
  • Number of edits per unit time (days, months) [Graph]

Users should be able to optionally download each of these sets of data as a CSV, as with the main list of results.

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptFeb 7 2018, 12:54 PM
Samwalton9 triaged this task as High priority.Feb 7 2018, 12:59 PM
Samwalton9 moved this task from Incoming to Features on the Hashtags board.
Samwalton9 lowered the priority of this task from High to Normal.Oct 3 2018, 10:09 AM

Might require a bit of reworking in how I've set up the search page since I may want to re-use the search form + stats box, but should really avoid duplicating all that code in the view and template where possible.

Samwalton9 updated the task description. (Show Details)Feb 14 2019, 11:35 AM
Samwalton9 updated the task description. (Show Details)

Hello @Samwalton9 @srishakatux , I am interested to work on this project and want to get started with it. How should I start contributing? Do I have to look for Issues and make PRs here?
Thanks for the help. :)

Hi @Samwalton9

I am Raghav Jajodia, a software engineer with two years of experience working in startups in the silicon valley of India. I recently went through the GSoC 2019 project ideas and I am really interested in working as a co-mentor for the project "Create a subpage for statistics and charts related to a hashtag search". I have decent experience working on the technology requirements for the project.

Why am I a good fit for this position?

I am a diligent FOSS contributor and have been contributing for more than 4 years. I have been involved with organisations such as Zulip, FOSSASIA, NRNB, OWASP to name a few. I am also a founding member of an Open Source organisation called Yogdaan.

I have been a student under the following:

  1. Google Summer of Code 2017
  2. OWASP Code Sprint
  3. FOSSASIA CodeHeat 2018 (Winner)

I have decent mentoring experience under programs like:

  1. IIT Kharagpur Winter of Code Mentor
  2. Google Code In Mentor
  3. Google Summer of Code 2018
  4. Rails Girls Summer of Code 2017
  5. Wootech Mentorship Program Singapore

It would love to get involved with Wikimedia and be an active contributor to its projects. It would be great if you could let me know if I could co-mentor for this project?

Looking forward to your response.

Regards,
Raghav Jajodia
Linkedin: https://www.linkedin.com/in/jajodiaraghav/
Github: https://github.com/jajodiaraghav

Hi @ParthS007 - yes, please feel free to take on any of the unassigned tasks on the Phab board and make PRs at the repo you linked. T216393, T216614, T216398, or T216399 might be good places to start :)

Samwalton9 moved this task from Features to Planned on the Hashtags board.Feb 26 2019, 2:34 PM

Hello, I am Pratik Mishra .This project seems interesting to me and I would like to contribute in this Project .I have prior experience in Python, Django, HTML, CSS, Javascript.I have also experience in participating in Open Source.I guess I have to look upon the above mentioned issue -
T216393: Database is continually denying access to root@localhost
T216398: Allow AND/OR searching for multiple hashtags
T216399: Allow wildcard hashtag searches
T216614: Review and improve project test coverage

Please feel free to contribute to unassigned tasks on the Hashtags workboard :)

Hello, I am interested in this project for GSoC'19.

i want to contribute on the project...

@Samwalton9 I am thinking of taking up this project as a part of my GSoC 2019 project. I had a few doubts:

  1. Do we need to create another page which will contain only statistics and charts or do we have to edit the pre-existing page in such a way that the statistics and charts will appear below the hashtag itself using the Bitergia's analytics

    https://wikimedia.biterg.io/
  1. How will we be creating the charts and the statistics using the acquired data?

Hello all I am Rashul Chutani BTech student at IIT Delhi aspirant for GSoC 2019.
I have been working with Frontend and Backend Technologies since long and I have worked both in Front end and Back end (Django/Python )
Projects I have worked earlier (Open Source Code Published) include
https://rashulchutani.github.io/(This website has all Front end Technologies including HTML CSS (Bootstrap CSS also) Java Script (Comment Box and Parallax) and Bootstrap )
http://rashulchutani0789.pythonanywhere.com/
(Used Django Framework to build a comprehensive Web Application for a blog Implemented Features Like Creating , editing and deleting a Blog Post (Object) All Backend implemented in Django using Models,Views,Templates,etc. features http://rashulchutani0789.pythonanywhere.com/admin page allows the superuser to add /delete/edit Blog Posts)
I would definitely like to work with WikiMedia this summer for this project. Please suggest me where to start with (code Base Links /Issues etc.) so that I can set up a draft proposal ASAP.

Thanks in advance.
Regards
Rashul Chutani

In general: Asking again and again "where to start" will not change the existing answer: Please read T186706#4968434 and T186706#4990685. Thanks.

@Ssomansh: There is no "pre-existing page" I think? If you think there is a pre-existing page for statistics related to hashtags in Wikimedia edit summaries (note the three emphases by me), feel free to link to it.

@Aklapper Are we expected to create the actual tables or graphs too or just the back end part of getting the data and displaying it while saving the data for creating graphs and tables later?

@Ssomansh: I don't know. I do not mentor this task, hence not sure why you ask me specifically. :) My understanding of the task summary is: both.

Yes please feel free to work on existing open tasks for the tool, though I think many (if not most) have now had work done on them and pull requests submitted!

@Ssomansh

  1. I think this would work best as its own page, linked from the results for a search. I'm not familiar with what wikimedia.biterg.io is.
  1. That's open to discussion. All the data will be available from the database to manipulate. What tools or packages we use to display that data is flexible - if the person working on this is familiar with a particular javascript library or django package then we can go with that. Otherwise part of the project timeline might include researching the best tool for the job.

Are we expected to create the actual tables or graphs too or just the back end part of getting the data and displaying it while saving the data for creating graphs and tables later?

The task encompasses both of these things - at any rate getting the data to the correct page should be quite straightforward :)

I am really interested in the project "Create a subpage for statistics and charts related to a hashtag search". I just want to know how to get started and where I can get the required resources.

@Samwalton9 Hey Sam! I am Juma Ali, Jay Czar(nickname). I am a young and vibrant computer scientist who is excited about creating an impact through code. This project has got my curiosity burning and I am really interested in contributing to this project. Kindly give me a heads up on the fixes and bugs I can start with. Thank you!

Hi and welcome @JayCzar! Please see T186706#4968434 above. Thanks.

Piyu34 added a subscriber: Piyu34.Mar 21 2019, 2:40 PM

Hello Sir ,
I am Priya Agrawal . I am interested in this project. I am familiar with HTML/CSS , python and framework.
Thank you !

Hey all - thanks for all the interest in this project! You're now welcome to submit proposals until April 9. Please add them as a subtask (click Edit Related Tasks on the right, then Create or Edit subtasks) so I see them :)

@Samwalton9 Hey Sam! Thanks for the update.

Hi @Samwalton9

I am Prakhar Gurunani, a web developer. I recently went through the GSoC 2019 project ideas and I am really interested in participating as a student for the project Create a subpage for statistics and charts related to a hashtag search. I have decent experience working on the technology requirements for the project.

I have experience in HTML, CSS (Also Bootstrap 3), Python, Django, and creating static websites with Markdown.

I have created a open source project Trashware in python which automatically separates waste material automatically into recyclable and non-recyclable bins using Clarifai Python client. Currently, I am developing a social networking forum for technology enthusiasts VellXR with Django.

Looking forward to your response.

Regards,
Prakhar Gurunani
https://www.prakhargurunani.com/
Github: https://github.com/prakhargurunani

Hi @PrakharGurunani - per my message above, you are now welcome to submit proposals for this project. Please feel free to add them as subtasks to this one.

@Samwalton9
Do we have to create a dummy database or use some online database for displaying charts ?

The database already exists in the production environment. Locally, a database will be initialised as part of the docker container setup, and by default will simply start collecting data in the same way as the live tool. No other database should be necessary :)

PrakharGurunani added a comment.EditedMar 28 2019, 11:52 AM

I am not able to setup the application on local development machine due to some Docker issues. Any tutorial about Docker ?

I am not able to setup the application on local development machine due to some Docker issues. Any tutorial about Docker ?

See Docker development environment on https://www.mediawiki.org/wiki/How_to_become_a_MediaWiki_hacker

Just a reminder to everyone that the deadline for proposals is tomorrow (Tuesday, April 9) at 18:00 UTC. In addition to a Phabricator task here, you also need to ensure that you've uploaded a PDF version of your proposal to the GSOC website (https://summerofcode.withgoogle.com/) by the deadline!

@AdityaJ @ParthS007 @JayCzar

okay @Samwalton9, we will upload the PDF as well. 👍

Syash5 added a subscriber: Syash5.Apr 8 2019, 3:03 PM

@Samwalton9 sir i created a pull request can you please help resolving the error.

@Syash5: Hi, nobody can help if you do not explain which error you see. Please see https://www.mediawiki.org/wiki/How_to_become_a_MediaWiki_hacker#Feedback,_questions_and_support and provide way more info in your pull request on Github. Thanks.

Samwalton9 closed this task as Resolved.Jul 5 2019, 11:47 AM
Samwalton9 assigned this task to AdityaJ.
Samwalton9 moved this task from Planned to Doing on the Hashtags board.

https://github.com/WikipediaLibrary/hashtags/pull/31 is now merged and the MVP for this project is complete + live!

Samwalton9 added a subscriber: Samwalton9.